import {
  __name
} from "./chunk-INDHDMU3.mjs";

// src/lifecycles.ts
import { getCurrentInstance, nextTick, onMounted, onBeforeMount, onBeforeUnmount, onUnmounted } from "vue";
function tryOnMounted(fn, sync = true) {
  if (getCurrentInstance())
    onMounted(fn);
  else if (sync)
    fn();
  else
    nextTick(fn);
}
__name(tryOnMounted, "tryOnMounted");
function tryOnBeforeMount(fn, sync = true) {
  if (getCurrentInstance())
    onBeforeMount(fn);
  else if (sync)
    fn();
  else
    nextTick(fn);
}
__name(tryOnBeforeMount, "tryOnBeforeMount");
function tryOnBeforeUnmount(fn) {
  if (getCurrentInstance())
    onBeforeUnmount(fn);
}
__name(tryOnBeforeUnmount, "tryOnBeforeUnmount");
function tryOnUnmounted(fn) {
  if (getCurrentInstance())
    onUnmounted(fn);
}
__name(tryOnUnmounted, "tryOnUnmounted");

export {
  tryOnMounted,
  tryOnBeforeMount,
  tryOnBeforeUnmount,
  tryOnUnmounted
};
