"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/lifecycles.ts
var lifecycles_exports = {};
__export(lifecycles_exports, {
  tryOnBeforeMount: () => tryOnBeforeMount,
  tryOnBeforeUnmount: () => tryOnBeforeUnmount,
  tryOnMounted: () => tryOnMounted,
  tryOnUnmounted: () => tryOnUnmounted
});
module.exports = __toCommonJS(lifecycles_exports);
var import_vue = require("vue");
function tryOnMounted(fn, sync = true) {
  if ((0, import_vue.getCurrentInstance)())
    (0, import_vue.onMounted)(fn);
  else if (sync)
    fn();
  else
    (0, import_vue.nextTick)(fn);
}
__name(tryOnMounted, "tryOnMounted");
function tryOnBeforeMount(fn, sync = true) {
  if ((0, import_vue.getCurrentInstance)())
    (0, import_vue.onBeforeMount)(fn);
  else if (sync)
    fn();
  else
    (0, import_vue.nextTick)(fn);
}
__name(tryOnBeforeMount, "tryOnBeforeMount");
function tryOnBeforeUnmount(fn) {
  if ((0, import_vue.getCurrentInstance)())
    (0, import_vue.onBeforeUnmount)(fn);
}
__name(tryOnBeforeUnmount, "tryOnBeforeUnmount");
function tryOnUnmounted(fn) {
  if ((0, import_vue.getCurrentInstance)())
    (0, import_vue.onUnmounted)(fn);
}
__name(tryOnUnmounted, "tryOnUnmounted");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  tryOnBeforeMount,
  tryOnBeforeUnmount,
  tryOnMounted,
  tryOnUnmounted
});
